JazzSSParser Class Referencefinal

the main class to read a Jazz spreadsheet v1 (Lotus) document and some databases. More...

`#include <JazzSSParser.hxx>`

Inheritance diagram for JazzSSParser:

## Public Member Functions

| JazzSSParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor
| ~JazzSSParser () final
| destructor
bool | checkHeader (MWAWHeader *header, bool strict=false) final
| checks if the document header is correct (or not)
void | parse (librevenge::RVNGSpreadsheetInterface *documentInterface) final
| the main parse function
Public Member Functions inherited from MWAWSpreadsheetParser
| ~MWAWSpreadsheetParser () override
| destructor
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor
int | version () const
| returns the works version
MWAWParserStatePtr | getParserState ()
| returns the parser state
MWAWHeader * | getHeader ()
| returns the header
MWAWInputStreamPtr & | getInput ()
| returns the actual input
MWAWListenerPtr | getMainListener ()
| returns the main listener
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter
MWAWFontManagerPtr & | getFontManager ()
| returns the font manager
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension
double | getFormLength () const
| returns the form length
double | getFormWidth () const
| returns the form width
double | getPageLength () const
| returns the page length (form length without margin )
double | getPageWidth () const
| returns the page width (form width without margin )
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document

## Protected Member Functions

void | createDocument (librevenge::RVNGSpreadsheetInterface *documentInterface)
| creates the listener which will be associated to the document
bool | createZones ()
| finds the different objects zones
bool | sendSpreadsheet ()
| sends the spreadsheet
bool | readZone11 (long endPos)
| reads a query/name/range... data (zone 11)
bool | readCell (int id, long endPos)
| reads a cell content data
bool | readSheetSize (long endPos)
| reads sheet size
bool | readDocument (long endPos)
| read the basic document zones (zone 15): selection, columns' width, default font, preferences...
bool | readCell (MWAWVec2i actPos, MWAWCellContent::FormulaInstruction &instr)
bool | readFormula (long endPos, MWAWVec2i const &pos, std::vector< MWAWCellContent::FormulaInstruction > &formula, std::string &error)
Protected Member Functions inherited from MWAWSpreadsheetParser
| MWAWSpreadsheetParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWSpreadsheetParser (MWAWParserStatePtr const &state)
| constructor using a state
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWParser (MWAWParserStatePtr const &state)
| constructor using a state
void | setVersion (int vers)
| sets the document's version
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener
void | resetGraphicListener ()
| resets the listener
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener
void | resetPresentationListener ()
| resets the listener
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener
void | resetSpreadsheetListener ()
| resets the listener
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener
void | resetTextListener ()
| resets the listener
void | setAsciiName (char const *name)
| Debugging: change the default ascii file.
std::string const & | asciiName () const
| return the ascii file name

## Protected Attributes

std::shared_ptr< JazzSSParserInternal::State > | m_state
| the state

## Friends

class | JazzSSParserInternal::SubDocument

## Detailed Description

the main class to read a Jazz spreadsheet v1 (Lotus) document and some databases.

Note
  need more files to be sure to treat all documents
  a database is stored as a spreadsheet in the form [A][B] [C][empty] where [B] corresponds to the report's definitions and [C] corresponds to the database's contents

## Constructor & Destructor Documentation

## JazzSSParser()

JazzSSParser::JazzSSParser | ( | MWAWInputStreamPtr const & | input,
|  | MWAWRSRCParserPtr const & | rsrcParser,
|  | MWAWHeader * | header )

constructor

## ~JazzSSParser()

JazzSSParser::~JazzSSParser | ( |  | ) |

final

destructor

## Member Function Documentation

## checkHeader()

bool JazzSSParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = false )

final virtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by JazzSSParserInternal::SubDocument, and parse().

## createDocument()

void JazzSSParser::createDocument | ( | librevenge::RVNGSpreadsheetInterface * | documentInterface | ) |

protected

creates the listener which will be associated to the document

Referenced by JazzSSParserInternal::SubDocument, and parse().

## createZones()

bool JazzSSParser::createZones | ( |  | ) |

protected

finds the different objects zones

Referenced by JazzSSParserInternal::SubDocument, and parse().

## parse()

void JazzSSParser::parse | ( | librevenge::RVNGSpreadsheetInterface * | documentInterface | ) |

final virtual

the main parse function

Implements MWAWSpreadsheetParser.

Referenced by JazzSSParserInternal::SubDocument.

## readCell() [1/2]

bool JazzSSParser::readCell | ( | int | id,
|  | long | endPos )

protected

reads a cell content data

Referenced by createZones(), JazzSSParserInternal::SubDocument, and readFormula().

## readCell() [2/2]

bool JazzSSParser::readCell | ( | MWAWVec2i | actPos,
|  | MWAWCellContent::FormulaInstruction & | instr )

protected

## readDocument()

bool JazzSSParser::readDocument | ( | long | endPos | ) |

protected

read the basic document zones (zone 15): selection, columns' width, default font, preferences...

Referenced by createZones(), and JazzSSParserInternal::SubDocument.

## readFormula()

bool JazzSSParser::readFormula | ( | long | endPos,
|  | MWAWVec2i const & | pos,
|  | std::vector< MWAWCellContent::FormulaInstruction > & | formula,
|  | std::string & | error )

protected

Referenced by JazzSSParserInternal::SubDocument, and readCell().

## readSheetSize()

bool JazzSSParser::readSheetSize | ( | long | endPos | ) |

protected

reads sheet size

Referenced by createZones(), and JazzSSParserInternal::SubDocument.

## readZone11()

bool JazzSSParser::readZone11 | ( | long | endPos | ) |

protected

reads a query/name/range... data (zone 11)

Referenced by createZones(), and JazzSSParserInternal::SubDocument.

## sendSpreadsheet()

bool JazzSSParser::sendSpreadsheet | ( |  | ) |

protected

sends the spreadsheet

Referenced by JazzSSParserInternal::SubDocument, and parse().

## Friends And Related Symbol Documentation

## JazzSSParserInternal::SubDocument

friend class JazzSSParserInternal::SubDocument

friend

## Member Data Documentation

## m_state

std::shared_ptr<JazzSSParserInternal::State> JazzSSParser::m_state

protected

the state

Referenced by checkHeader(), createZones(), JazzSSParser(), readCell(), readDocument(), readSheetSize(), and sendSpreadsheet().

The documentation for this class was generated from the following files:

- JazzSSParser.hxx
- JazzSSParser.cxx